/* DateRange.c generated by valac 0.43.6, the Vala compiler
 * generated from DateRange.vala, do not modify */

/*
 * Copyright 2011-2018 elementary, Inc. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementaryos.org>
 */
/* Represents date range from 'first' to 'last' inclusive */

#include <glib-object.h>
#include <gee.h>
#include <glib.h>

#define UTIL_TYPE_DATE_RANGE (util_date_range_get_type ())
#define UTIL_DATE_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UTIL_TYPE_DATE_RANGE, UtilDateRange))
#define UTIL_DATE_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UTIL_TYPE_DATE_RANGE, UtilDateRangeClass))
#define UTIL_IS_DATE_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UTIL_TYPE_DATE_RANGE))
#define UTIL_IS_DATE_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UTIL_TYPE_DATE_RANGE))
#define UTIL_DATE_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UTIL_TYPE_DATE_RANGE, UtilDateRangeClass))

typedef struct _UtilDateRange UtilDateRange;
typedef struct _UtilDateRangeClass UtilDateRangeClass;
typedef struct _UtilDateRangePrivate UtilDateRangePrivate;
enum  {
	UTIL_DATE_RANGE_0_PROPERTY,
	UTIL_DATE_RANGE_FIRST_DT_PROPERTY,
	UTIL_DATE_RANGE_LAST_DT_PROPERTY,
	UTIL_DATE_RANGE_DAYS_PROPERTY,
	UTIL_DATE_RANGE_ELEMENT_TYPE_PROPERTY,
	UTIL_DATE_RANGE_NUM_PROPERTIES
};
static GParamSpec* util_date_range_properties[UTIL_DATE_RANGE_NUM_PROPERTIES];
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define UTIL_TYPE_DATE_ITERATOR (util_date_iterator_get_type ())
#define UTIL_DATE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UTIL_TYPE_DATE_ITERATOR, UtilDateIterator))
#define UTIL_DATE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), UTIL_TYPE_DATE_ITERATOR, UtilDateIteratorClass))
#define UTIL_IS_DATE_ITERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UTIL_TYPE_DATE_ITERATOR))
#define UTIL_IS_DATE_ITERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), UTIL_TYPE_DATE_ITERATOR))
#define UTIL_DATE_ITERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), UTIL_TYPE_DATE_ITERATOR, UtilDateIteratorClass))

typedef struct _UtilDateIterator UtilDateIterator;
typedef struct _UtilDateIteratorClass UtilDateIteratorClass;

struct _UtilDateRange {
	GObject parent_instance;
	UtilDateRangePrivate * priv;
};

struct _UtilDateRangeClass {
	GObjectClass parent_class;
};

struct _UtilDateRangePrivate {
	GDateTime* _first_dt;
	GDateTime* _last_dt;
};

static gint UtilDateRange_private_offset;
static gpointer util_date_range_parent_class = NULL;
static GeeTraversableIface * util_date_range_gee_traversable_parent_iface = NULL;
static GeeIterableIface * util_date_range_gee_iterable_parent_iface = NULL;

GType util_date_range_get_type (void) G_GNUC_CONST;
static gboolean util_date_range_real_foreach (GeeTraversable* base,
                                       GeeForallFunc f,
                                       gpointer f_target);
UtilDateRange* util_date_range_new (GDateTime* first,
                                    GDateTime* last);
UtilDateRange* util_date_range_construct (GType object_type,
                                          GDateTime* first,
                                          GDateTime* last);
static void util_date_range_set_first_dt (UtilDateRange* self,
                                   GDateTime* value);
static void util_date_range_set_last_dt (UtilDateRange* self,
                                  GDateTime* value);
UtilDateRange* util_date_range_new_copy (UtilDateRange* date_range);
UtilDateRange* util_date_range_construct_copy (GType object_type,
                                               UtilDateRange* date_range);
GDateTime* util_date_range_get_first_dt (UtilDateRange* self);
GDateTime* util_date_range_get_last_dt (UtilDateRange* self);
gboolean util_date_range_equals (UtilDateRange* self,
                                 UtilDateRange* other);
static GeeIterator* util_date_range_real_iterator (GeeIterable* base);
UtilDateIterator* util_date_iterator_new (UtilDateRange* range);
UtilDateIterator* util_date_iterator_construct (GType object_type,
                                                UtilDateRange* range);
GType util_date_iterator_get_type (void) G_GNUC_CONST;
gboolean util_date_range_contains (UtilDateRange* self,
                                   GDateTime* time);
GeeSortedSet* util_date_range_to_set (UtilDateRange* self);
GeeList* util_date_range_to_list (UtilDateRange* self);
gboolean util_date_range_datetime_equal_func (UtilDateRange* self,
                                              GDateTime* a,
                                              GDateTime* b);
gint64 util_date_range_get_days (UtilDateRange* self);
static void util_date_range_finalize (GObject * obj);
static void _vala_util_date_range_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_util_date_range_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
util_date_range_get_instance_private (UtilDateRange* self)
{
	return G_STRUCT_MEMBER_P (self, UtilDateRange_private_offset);
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 28 "../src/DateRange.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 136 "DateRange.c"
}

static gboolean
util_date_range_real_foreach (GeeTraversable* base,
                              GeeForallFunc f,
                              gpointer f_target)
{
	UtilDateRange * self;
	gboolean result = FALSE;
#line 26 "../src/DateRange.vala"
	self = (UtilDateRange*) base;
#line 148 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp0_;
#line 27 "../src/DateRange.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) self);
#line 27 "../src/DateRange.vala"
		_date_it = _tmp0_;
#line 27 "../src/DateRange.vala"
		while (TRUE) {
#line 158 "DateRange.c"
			GeeIterator* _tmp1_;
			GDateTime* date = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GDateTime* _tmp4_;
			GDateTime* _tmp5_;
#line 27 "../src/DateRange.vala"
			_tmp1_ = _date_it;
#line 27 "../src/DateRange.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 27 "../src/DateRange.vala"
				break;
#line 171 "DateRange.c"
			}
#line 27 "../src/DateRange.vala"
			_tmp2_ = _date_it;
#line 27 "../src/DateRange.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 27 "../src/DateRange.vala"
			date = (GDateTime*) _tmp3_;
#line 28 "../src/DateRange.vala"
			_tmp4_ = date;
#line 28 "../src/DateRange.vala"
			_tmp5_ = _g_date_time_ref0 (_tmp4_);
#line 28 "../src/DateRange.vala"
			if (f (_tmp5_, f_target) == FALSE) {
#line 29 "../src/DateRange.vala"
				result = FALSE;
#line 29 "../src/DateRange.vala"
				_g_date_time_unref0 (date);
#line 29 "../src/DateRange.vala"
				_g_object_unref0 (_date_it);
#line 29 "../src/DateRange.vala"
				return result;
#line 193 "DateRange.c"
			}
#line 27 "../src/DateRange.vala"
			_g_date_time_unref0 (date);
#line 197 "DateRange.c"
		}
#line 27 "../src/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 201 "DateRange.c"
	}
#line 33 "../src/DateRange.vala"
	result = TRUE;
#line 33 "../src/DateRange.vala"
	return result;
#line 207 "DateRange.c"
}

UtilDateRange*
util_date_range_construct (GType object_type,
                           GDateTime* first,
                           GDateTime* last)
{
	UtilDateRange * self = NULL;
#line 42 "../src/DateRange.vala"
	g_return_val_if_fail (first != NULL, NULL);
#line 42 "../src/DateRange.vala"
	g_return_val_if_fail (last != NULL, NULL);
#line 42 "../src/DateRange.vala"
	self = (UtilDateRange*) g_object_new (object_type, NULL);
#line 43 "../src/DateRange.vala"
	util_date_range_set_first_dt (self, first);
#line 44 "../src/DateRange.vala"
	util_date_range_set_last_dt (self, last);
#line 42 "../src/DateRange.vala"
	return self;
#line 228 "DateRange.c"
}

UtilDateRange*
util_date_range_new (GDateTime* first,
                     GDateTime* last)
{
#line 42 "../src/DateRange.vala"
	return util_date_range_construct (UTIL_TYPE_DATE_RANGE, first, last);
#line 237 "DateRange.c"
}

UtilDateRange*
util_date_range_construct_copy (GType object_type,
                                UtilDateRange* date_range)
{
	UtilDateRange * self = NULL;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 47 "../src/DateRange.vala"
	g_return_val_if_fail (date_range != NULL, NULL);
#line 48 "../src/DateRange.vala"
	_tmp0_ = date_range->priv->_first_dt;
#line 48 "../src/DateRange.vala"
	_tmp1_ = date_range->priv->_last_dt;
#line 48 "../src/DateRange.vala"
	self = (UtilDateRange*) util_date_range_construct (object_type, _tmp0_, _tmp1_);
#line 47 "../src/DateRange.vala"
	return self;
#line 257 "DateRange.c"
}

UtilDateRange*
util_date_range_new_copy (UtilDateRange* date_range)
{
#line 47 "../src/DateRange.vala"
	return util_date_range_construct_copy (UTIL_TYPE_DATE_RANGE, date_range);
#line 265 "DateRange.c"
}

gboolean
util_date_range_equals (UtilDateRange* self,
                        UtilDateRange* other)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
#line 51 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../src/DateRange.vala"
	g_return_val_if_fail (other != NULL, FALSE);
#line 52 "../src/DateRange.vala"
	_tmp1_ = self->priv->_first_dt;
#line 52 "../src/DateRange.vala"
	_tmp2_ = other->priv->_first_dt;
#line 52 "../src/DateRange.vala"
	if (_tmp1_ == _tmp2_) {
#line 286 "DateRange.c"
		GDateTime* _tmp3_;
		GDateTime* _tmp4_;
#line 52 "../src/DateRange.vala"
		_tmp3_ = self->priv->_last_dt;
#line 52 "../src/DateRange.vala"
		_tmp4_ = other->priv->_last_dt;
#line 52 "../src/DateRange.vala"
		_tmp0_ = _tmp3_ == _tmp4_;
#line 295 "DateRange.c"
	} else {
#line 52 "../src/DateRange.vala"
		_tmp0_ = FALSE;
#line 299 "DateRange.c"
	}
#line 52 "../src/DateRange.vala"
	result = _tmp0_;
#line 52 "../src/DateRange.vala"
	return result;
#line 305 "DateRange.c"
}

static GeeIterator*
util_date_range_real_iterator (GeeIterable* base)
{
	UtilDateRange * self;
	GeeIterator* result = NULL;
	UtilDateIterator* _tmp0_;
#line 61 "../src/DateRange.vala"
	self = (UtilDateRange*) base;
#line 62 "../src/DateRange.vala"
	_tmp0_ = util_date_iterator_new (self);
#line 62 "../src/DateRange.vala"
	result = (GeeIterator*) _tmp0_;
#line 62 "../src/DateRange.vala"
	return result;
#line 322 "DateRange.c"
}

gboolean
util_date_range_contains (UtilDateRange* self,
                          GDateTime* time)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GDateTime* _tmp1_;
#line 65 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/DateRange.vala"
	g_return_val_if_fail (time != NULL, FALSE);
#line 66 "../src/DateRange.vala"
	_tmp1_ = self->priv->_first_dt;
#line 66 "../src/DateRange.vala"
	if (g_date_time_compare (_tmp1_, time) < 1) {
#line 340 "DateRange.c"
		GDateTime* _tmp2_;
#line 66 "../src/DateRange.vala"
		_tmp2_ = self->priv->_last_dt;
#line 66 "../src/DateRange.vala"
		_tmp0_ = g_date_time_compare (_tmp2_, time) > -1;
#line 346 "DateRange.c"
	} else {
#line 66 "../src/DateRange.vala"
		_tmp0_ = FALSE;
#line 350 "DateRange.c"
	}
#line 66 "../src/DateRange.vala"
	result = _tmp0_;
#line 66 "../src/DateRange.vala"
	return result;
#line 356 "DateRange.c"
}

GeeSortedSet*
util_date_range_to_set (UtilDateRange* self)
{
	GeeSortedSet* result = NULL;
	GeeTreeSet* set = NULL;
	GeeTreeSet* _tmp0_;
#line 69 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/DateRange.vala"
	_tmp0_ = gee_tree_set_new (G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, (GCompareDataFunc) g_date_time_compare, NULL, NULL);
#line 70 "../src/DateRange.vala"
	set = _tmp0_;
#line 371 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp1_;
#line 72 "../src/DateRange.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) self);
#line 72 "../src/DateRange.vala"
		_date_it = _tmp1_;
#line 72 "../src/DateRange.vala"
		while (TRUE) {
#line 381 "DateRange.c"
			GeeIterator* _tmp2_;
			GDateTime* date = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeTreeSet* _tmp5_;
			GDateTime* _tmp6_;
#line 72 "../src/DateRange.vala"
			_tmp2_ = _date_it;
#line 72 "../src/DateRange.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 72 "../src/DateRange.vala"
				break;
#line 394 "DateRange.c"
			}
#line 72 "../src/DateRange.vala"
			_tmp3_ = _date_it;
#line 72 "../src/DateRange.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 72 "../src/DateRange.vala"
			date = (GDateTime*) _tmp4_;
#line 73 "../src/DateRange.vala"
			_tmp5_ = set;
#line 73 "../src/DateRange.vala"
			_tmp6_ = date;
#line 73 "../src/DateRange.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 72 "../src/DateRange.vala"
			_g_date_time_unref0 (date);
#line 410 "DateRange.c"
		}
#line 72 "../src/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 414 "DateRange.c"
	}
#line 76 "../src/DateRange.vala"
	result = (GeeSortedSet*) set;
#line 76 "../src/DateRange.vala"
	return result;
#line 420 "DateRange.c"
}

GeeList*
util_date_range_to_list (UtilDateRange* self)
{
	GeeList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
#line 79 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 80 "../src/DateRange.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_DATE_TIME, (GBoxedCopyFunc) g_date_time_ref, (GDestroyNotify) g_date_time_unref, (GeeEqualDataFunc) util_date_range_datetime_equal_func, g_object_ref (self), g_object_unref);
#line 80 "../src/DateRange.vala"
	list = _tmp0_;
#line 435 "DateRange.c"
	{
		GeeIterator* _date_it = NULL;
		GeeIterator* _tmp1_;
#line 82 "../src/DateRange.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) self);
#line 82 "../src/DateRange.vala"
		_date_it = _tmp1_;
#line 82 "../src/DateRange.vala"
		while (TRUE) {
#line 445 "DateRange.c"
			GeeIterator* _tmp2_;
			GDateTime* date = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			GeeArrayList* _tmp5_;
			GDateTime* _tmp6_;
#line 82 "../src/DateRange.vala"
			_tmp2_ = _date_it;
#line 82 "../src/DateRange.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 82 "../src/DateRange.vala"
				break;
#line 458 "DateRange.c"
			}
#line 82 "../src/DateRange.vala"
			_tmp3_ = _date_it;
#line 82 "../src/DateRange.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 82 "../src/DateRange.vala"
			date = (GDateTime*) _tmp4_;
#line 83 "../src/DateRange.vala"
			_tmp5_ = list;
#line 83 "../src/DateRange.vala"
			_tmp6_ = date;
#line 83 "../src/DateRange.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp5_, _tmp6_);
#line 82 "../src/DateRange.vala"
			_g_date_time_unref0 (date);
#line 474 "DateRange.c"
		}
#line 82 "../src/DateRange.vala"
		_g_object_unref0 (_date_it);
#line 478 "DateRange.c"
	}
#line 86 "../src/DateRange.vala"
	result = (GeeList*) list;
#line 86 "../src/DateRange.vala"
	return result;
#line 484 "DateRange.c"
}

gboolean
util_date_range_datetime_equal_func (UtilDateRange* self,
                                     GDateTime* a,
                                     GDateTime* b)
{
	gboolean result = FALSE;
#line 90 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 90 "../src/DateRange.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 90 "../src/DateRange.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 91 "../src/DateRange.vala"
	result = g_date_time_equal (a, b);
#line 91 "../src/DateRange.vala"
	return result;
#line 503 "DateRange.c"
}

GDateTime*
util_date_range_get_first_dt (UtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 24 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 24 "../src/DateRange.vala"
	_tmp0_ = self->priv->_first_dt;
#line 24 "../src/DateRange.vala"
	result = _tmp0_;
#line 24 "../src/DateRange.vala"
	return result;
#line 519 "DateRange.c"
}

static void
util_date_range_set_first_dt (UtilDateRange* self,
                              GDateTime* value)
{
#line 24 "../src/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 24 "../src/DateRange.vala"
	if (util_date_range_get_first_dt (self) != value) {
#line 530 "DateRange.c"
		GDateTime* _tmp0_;
#line 24 "../src/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 24 "../src/DateRange.vala"
		_g_date_time_unref0 (self->priv->_first_dt);
#line 24 "../src/DateRange.vala"
		self->priv->_first_dt = _tmp0_;
#line 24 "../src/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, util_date_range_properties[UTIL_DATE_RANGE_FIRST_DT_PROPERTY]);
#line 540 "DateRange.c"
	}
}

GDateTime*
util_date_range_get_last_dt (UtilDateRange* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
#line 25 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/DateRange.vala"
	_tmp0_ = self->priv->_last_dt;
#line 25 "../src/DateRange.vala"
	result = _tmp0_;
#line 25 "../src/DateRange.vala"
	return result;
#line 557 "DateRange.c"
}

static void
util_date_range_set_last_dt (UtilDateRange* self,
                             GDateTime* value)
{
#line 25 "../src/DateRange.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/DateRange.vala"
	if (util_date_range_get_last_dt (self) != value) {
#line 568 "DateRange.c"
		GDateTime* _tmp0_;
#line 25 "../src/DateRange.vala"
		_tmp0_ = _g_date_time_ref0 (value);
#line 25 "../src/DateRange.vala"
		_g_date_time_unref0 (self->priv->_last_dt);
#line 25 "../src/DateRange.vala"
		self->priv->_last_dt = _tmp0_;
#line 25 "../src/DateRange.vala"
		g_object_notify_by_pspec ((GObject *) self, util_date_range_properties[UTIL_DATE_RANGE_LAST_DT_PROPERTY]);
#line 578 "DateRange.c"
	}
}

gint64
util_date_range_get_days (UtilDateRange* self)
{
	gint64 result;
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
#line 37 "../src/DateRange.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 38 "../src/DateRange.vala"
	_tmp0_ = self->priv->_last_dt;
#line 38 "../src/DateRange.vala"
	_tmp1_ = self->priv->_first_dt;
#line 38 "../src/DateRange.vala"
	result = (gint64) (g_date_time_difference (_tmp0_, _tmp1_) / G_TIME_SPAN_DAY);
#line 38 "../src/DateRange.vala"
	return result;
#line 598 "DateRange.c"
}

static GType
util_date_range_real_get_element_type (GeeTraversable* base)
{
	GType result;
	UtilDateRange* self;
#line 56 "../src/DateRange.vala"
	self = (UtilDateRange*) base;
#line 57 "../src/DateRange.vala"
	result = G_TYPE_DATE_TIME;
#line 57 "../src/DateRange.vala"
	return result;
#line 612 "DateRange.c"
}

static void
util_date_range_class_init (UtilDateRangeClass * klass,
                            gpointer klass_data)
{
#line 23 "../src/DateRange.vala"
	util_date_range_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/DateRange.vala"
	g_type_class_adjust_private_offset (klass, &UtilDateRange_private_offset);
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_util_date_range_get_property;
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_util_date_range_set_property;
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (klass)->finalize = util_date_range_finalize;
#line 23 "../src/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_RANGE_FIRST_DT_PROPERTY, util_date_range_properties[UTIL_DATE_RANGE_FIRST_DT_PROPERTY] = g_param_spec_boxed ("first-dt", "first-dt", "first-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_RANGE_LAST_DT_PROPERTY, util_date_range_properties[UTIL_DATE_RANGE_LAST_DT_PROPERTY] = g_param_spec_boxed ("last-dt", "last-dt", "last-dt", G_TYPE_DATE_TIME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_RANGE_DAYS_PROPERTY, util_date_range_properties[UTIL_DATE_RANGE_DAYS_PROPERTY] = g_param_spec_int64 ("days", "days", "days", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/DateRange.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UTIL_DATE_RANGE_ELEMENT_TYPE_PROPERTY, util_date_range_properties[UTIL_DATE_RANGE_ELEMENT_TYPE_PROPERTY] = g_param_spec_gtype ("element-type", "element-type", "element-type", G_TYPE_NONE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 637 "DateRange.c"
}

static GType
util_date_range_gee_traversable_get_g_type (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return G_TYPE_DATE_TIME;
#line 645 "DateRange.c"
}

static GBoxedCopyFunc
util_date_range_gee_traversable_get_g_dup_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return g_date_time_ref;
#line 653 "DateRange.c"
}

static GDestroyNotify
util_date_range_gee_traversable_get_g_destroy_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return g_date_time_unref;
#line 661 "DateRange.c"
}

static void
util_date_range_gee_traversable_interface_init (GeeTraversableIface * iface,
                                                gpointer iface_data)
{
#line 23 "../src/DateRange.vala"
	util_date_range_gee_traversable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/DateRange.vala"
	iface->foreach = (gboolean (*) (GeeTraversable*, GeeForallFunc, gpointer)) util_date_range_real_foreach;
#line 23 "../src/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeTraversable *)) util_date_range_gee_traversable_get_g_type;
#line 23 "../src/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeTraversable *)) util_date_range_gee_traversable_get_g_dup_func;
#line 23 "../src/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeTraversable *)) util_date_range_gee_traversable_get_g_destroy_func;
#line 23 "../src/DateRange.vala"
	iface->get_element_type = util_date_range_real_get_element_type;
#line 680 "DateRange.c"
}

static GType
util_date_range_gee_iterable_get_g_type (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return G_TYPE_DATE_TIME;
#line 688 "DateRange.c"
}

static GBoxedCopyFunc
util_date_range_gee_iterable_get_g_dup_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return g_date_time_ref;
#line 696 "DateRange.c"
}

static GDestroyNotify
util_date_range_gee_iterable_get_g_destroy_func (UtilDateRange* self)
{
#line 23 "../src/DateRange.vala"
	return g_date_time_unref;
#line 704 "DateRange.c"
}

static void
util_date_range_gee_iterable_interface_init (GeeIterableIface * iface,
                                             gpointer iface_data)
{
#line 23 "../src/DateRange.vala"
	util_date_range_gee_iterable_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/DateRange.vala"
	iface->iterator = (GeeIterator* (*) (GeeIterable*)) util_date_range_real_iterator;
#line 23 "../src/DateRange.vala"
	iface->get_g_type = (GType (*) (GeeIterable *)) util_date_range_gee_iterable_get_g_type;
#line 23 "../src/DateRange.vala"
	iface->get_g_dup_func = (GBoxedCopyFunc (*) (GeeIterable *)) util_date_range_gee_iterable_get_g_dup_func;
#line 23 "../src/DateRange.vala"
	iface->get_g_destroy_func = (GDestroyNotify (*) (GeeIterable *)) util_date_range_gee_iterable_get_g_destroy_func;
#line 721 "DateRange.c"
}

static void
util_date_range_instance_init (UtilDateRange * self,
                               gpointer klass)
{
#line 23 "../src/DateRange.vala"
	self->priv = util_date_range_get_instance_private (self);
#line 730 "DateRange.c"
}

static void
util_date_range_finalize (GObject * obj)
{
	UtilDateRange * self;
#line 23 "../src/DateRange.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, UTIL_TYPE_DATE_RANGE, UtilDateRange);
#line 24 "../src/DateRange.vala"
	_g_date_time_unref0 (self->priv->_first_dt);
#line 25 "../src/DateRange.vala"
	_g_date_time_unref0 (self->priv->_last_dt);
#line 23 "../src/DateRange.vala"
	G_OBJECT_CLASS (util_date_range_parent_class)->finalize (obj);
#line 745 "DateRange.c"
}

GType
util_date_range_get_type (void)
{
	static volatile gsize util_date_range_type_id__volatile = 0;
	if (g_once_init_enter (&util_date_range_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UtilDateRangeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) util_date_range_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UtilDateRange), 0, (GInstanceInitFunc) util_date_range_instance_init, NULL };
		static const GInterfaceInfo gee_traversable_info = { (GInterfaceInitFunc) util_date_range_gee_traversable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo gee_iterable_info = { (GInterfaceInitFunc) util_date_range_gee_iterable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType util_date_range_type_id;
		util_date_range_type_id = g_type_register_static (G_TYPE_OBJECT, "UtilDateRange", &g_define_type_info, 0);
		g_type_add_interface_static (util_date_range_type_id, GEE_TYPE_TRAVERSABLE, &gee_traversable_info);
		g_type_add_interface_static (util_date_range_type_id, GEE_TYPE_ITERABLE, &gee_iterable_info);
		UtilDateRange_private_offset = g_type_add_instance_private (util_date_range_type_id, sizeof (UtilDateRangePrivate));
		g_once_init_leave (&util_date_range_type_id__volatile, util_date_range_type_id);
	}
	return util_date_range_type_id__volatile;
}

static void
_vala_util_date_range_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	UtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UTIL_TYPE_DATE_RANGE, UtilDateRange);
#line 23 "../src/DateRange.vala"
	switch (property_id) {
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		g_value_set_boxed (value, util_date_range_get_first_dt (self));
#line 23 "../src/DateRange.vala"
		break;
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		g_value_set_boxed (value, util_date_range_get_last_dt (self));
#line 23 "../src/DateRange.vala"
		break;
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_DAYS_PROPERTY:
#line 23 "../src/DateRange.vala"
		g_value_set_int64 (value, util_date_range_get_days (self));
#line 23 "../src/DateRange.vala"
		break;
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_ELEMENT_TYPE_PROPERTY:
#line 23 "../src/DateRange.vala"
		g_value_set_gtype (value, gee_traversable_get_element_type ((GeeTraversable*) self));
#line 23 "../src/DateRange.vala"
		break;
#line 800 "DateRange.c"
		default:
#line 23 "../src/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/DateRange.vala"
		break;
#line 806 "DateRange.c"
	}
}

static void
_vala_util_date_range_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	UtilDateRange * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, UTIL_TYPE_DATE_RANGE, UtilDateRange);
#line 23 "../src/DateRange.vala"
	switch (property_id) {
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_FIRST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		util_date_range_set_first_dt (self, g_value_get_boxed (value));
#line 23 "../src/DateRange.vala"
		break;
#line 23 "../src/DateRange.vala"
		case UTIL_DATE_RANGE_LAST_DT_PROPERTY:
#line 23 "../src/DateRange.vala"
		util_date_range_set_last_dt (self, g_value_get_boxed (value));
#line 23 "../src/DateRange.vala"
		break;
#line 832 "DateRange.c"
		default:
#line 23 "../src/DateRange.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/DateRange.vala"
		break;
#line 838 "DateRange.c"
	}
}

